VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "BlackHole"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public X As Single
Public Y As Single
Public Mass As Single
Public Sub Draw(ByVal obj As Object)
    obj.FillStyle = vbFSSolid
    obj.FillColor = RGB(64, 64, 64)
    obj.Circle (X, Y), Mass, vbBlack
End Sub
' Return True if the bullet has hit the black hole.
Public Function Hit(ByVal bullet_x As Single, ByVal bullet_y As Single, ByVal bullet_radius As Single) As Boolean
    Hit = CirclesOverlap(bullet_x, bullet_y, bullet_radius, X, Y, Mass)
End Function
' Pick random X, Y, and Mass.
Public Sub Randomize(ByVal xmin As Single, ByVal xmax As Single, ByVal ymin As Single, ByVal ymax As Single, ByVal MASS_MIN As Single, ByVal MASS_MAX As Single)
    X = xmin + Rnd * (xmax - xmin)
    Y = ymin + Rnd * (ymax - ymin)
    Mass = MASS_MIN + Rnd * (MASS_MAX - MASS_MIN)
End Sub

' Apply our gravity to this bullet's velocity.
Public Sub UpdateVelocity(ByVal bullet_x As Single, ByVal bullet_y As Single, ByRef vx As Single, ByRef vy As Single)
Const FORCE_SCALE As Integer = 10 ' Keep it interesting.
Dim dx As Single
Dim dy  As Single
Dim dist As Single
Dim dist2 As Single
Dim f As Single

    ' Calculate the force.
    dx = X - bullet_x
    dy = Y - bullet_y
    dist2 = dx * dx + dy * dy
    f = FORCE_SCALE * Mass / dist2

    ' Calculate the unit vector from the bullet towards the black hole.
    dist = Sqr(dist2)
    dx = dx / dist
    dy = dy / dist

    ' Apply the force components.
    vx = vx + dx * f
    vy = vy + dy * f
End Sub


