VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Blackhole Cannon"
   ClientHeight    =   7365
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   8910
   LinkTopic       =   "Form1"
   ScaleHeight     =   7365
   ScaleWidth      =   8910
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox picBoom 
      AutoSize        =   -1  'True
      Height          =   540
      Left            =   5640
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   480
      ScaleWidth      =   240
      TabIndex        =   6
      Top             =   0
      Visible         =   0   'False
      Width           =   300
   End
   Begin VB.TextBox txtSpeed 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   2160
      TabIndex        =   4
      Text            =   "50"
      Top             =   0
      Width           =   495
   End
   Begin VB.PictureBox picCanvas 
      Height          =   6975
      Left            =   0
      ScaleHeight     =   6915
      ScaleWidth      =   8835
      TabIndex        =   3
      Top             =   360
      Width           =   8895
   End
   Begin VB.CommandButton cmdFire 
      Caption         =   "Fire"
      Default         =   -1  'True
      Height          =   285
      Left            =   3120
      TabIndex        =   2
      Top             =   0
      Width           =   735
   End
   Begin VB.TextBox txtDegrees 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   600
      TabIndex        =   1
      Text            =   "0"
      Top             =   0
      Width           =   495
   End
   Begin VB.Timer tmrMoveShot 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   4560
      Top             =   0
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Speed"
      Height          =   195
      Index           =   1
      Left            =   1560
      TabIndex        =   5
      Top             =   0
      Width           =   465
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Angle"
      Height          =   195
      Index           =   0
      Left            =   0
      TabIndex        =   0
      Top             =   0
      Width           =   405
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileNewGame 
         Caption         =   "&New Game"
         Shortcut        =   ^N
      End
      Begin VB.Menu mnuFileExitSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_BlackHoles As New Collection

Private m_Theta As Single
Private m_BulletX As Single
Private m_BulletY As Single
Private m_Vx As Single
Private m_Vy As Single
Private m_Cx As Single
Private m_Cy As Single

Private Const TICKS_PER_SECOND As Single = 10

Private Const CANNON_LEN As Single = 20
Private Const CANNON_HGT As Single = 7

Private Declare Function Polygon Lib "gdi32" (ByVal hdc As Long, lpPoint As POINTAPI, ByVal nCount As Long) As Long
Private Type POINTAPI
    X As Long
    Y As Long
End Type
' Draw the game field.
Private Sub DrawField()
Const PI As Double = 3.14159265

Dim black_hole As BlackHole
Dim pts() As POINTAPI

    picCanvas.Cls

    ' Draw the black holes.
    For Each black_hole In m_BlackHoles
        black_hole.Draw picCanvas
    Next black_hole

    ' Draw the launch tube.
    On Error Resume Next
    m_Theta = CSng(txtDegrees.Text) * PI / 180
    If Err.Number <> 0 Then
        m_Theta = 0
        Err.Clear
    End If
    If m_Theta < -PI / 2 Then m_Theta = -PI / 2
    If m_Theta > PI / 2 Then m_Theta = PI / 2
    On Error GoTo 0

    m_Cx = CANNON_HGT / 2
    m_Cy = picCanvas.ScaleHeight / 2
    ReDim pts(1 To 4)
    pts(1).X = m_Cx - CANNON_HGT * Cos(PI / 2 - m_Theta) / 2: pts(1).Y = m_Cy - CANNON_HGT * Sin(PI / 2 - m_Theta) / 2
    pts(2).X = pts(1).X + CANNON_LEN * Cos(m_Theta): pts(2).Y = pts(1).Y - CANNON_LEN * Sin(m_Theta)
    pts(3).X = pts(2).X + CANNON_HGT * Cos(PI / 2 - m_Theta): pts(3).Y = pts(2).Y + CANNON_HGT * Sin(PI / 2 - m_Theta)
    pts(4).X = pts(3).X - CANNON_LEN * Cos(m_Theta): pts(4).Y = pts(3).Y + CANNON_LEN * Sin(m_Theta)
    picCanvas.DrawMode = vbCopyPen
    picCanvas.ForeColor = vbBlack
    picCanvas.FillColor = RGB(0, 128, 255)
    picCanvas.FillStyle = vbSolid
    picCanvas.DrawStyle = vbSolid
    Polygon picCanvas.hdc, pts(1), UBound(pts)

    ' Draw the cannon's base.
    picCanvas.FillColor = RGB(0, 64, 128)
    picCanvas.Circle (0, m_Cy), CANNON_HGT * 1.5, vbBlack

    ' Draw the target.
    picCanvas.FillColor = vbRed
    picCanvas.Circle (picCanvas.ScaleWidth, m_Cy), 15, vbRed
    picCanvas.FillColor = vbWhite
    picCanvas.Circle (picCanvas.ScaleWidth, m_Cy), 10, vbRed
    picCanvas.FillColor = vbRed
    picCanvas.Circle (picCanvas.ScaleWidth, m_Cy), 5, vbRed

    ' Set the initial bullet position.
    m_BulletX = m_Cx + (CANNON_LEN + CANNON_HGT / 2) * Cos(m_Theta)
    m_BulletY = m_Cy - (CANNON_LEN + CANNON_HGT / 2) * Sin(m_Theta)
End Sub
Private Sub cmdFire_Click()
Dim speed As Single

    ' Redraw.
    DrawField

    ' Get the speed.
    On Error Resume Next
    speed = CSng(txtSpeed.Text)
    If Err.Number <> 0 Then
        MsgBox "Invalid speed", vbExclamation, "Invalid Speed"
        Exit Sub
    End If
    On Error GoTo 0
    If speed < 1 Then
        MsgBox "Speed must be at least 1 kps", vbExclamation, "Invalid Speed"
        Exit Sub
    End If

    ' Get the speed components in meters per tick.
    m_Vx = speed * Cos(m_Theta) / TICKS_PER_SECOND
    m_Vy = -speed * Sin(m_Theta) / TICKS_PER_SECOND ' Negative to go up.

    ' Disable UI elements.
    cmdFire.Enabled = False
    txtDegrees.Enabled = False
    txtSpeed.Enabled = False
    Screen.MousePointer = vbHourglass
    DoEvents

    ' Start moving the cannon ball.
    picCanvas.FillColor = vbRed
    tmrMoveShot.Enabled = True
End Sub


Private Sub Form_Load()
    tmrMoveShot.Enabled = False
    tmrMoveShot.Interval = 1 / TICKS_PER_SECOND * 1000

    picCanvas.ScaleMode = vbPixels
    picCanvas.AutoRedraw = True

    Randomize
    mnuFileNewGame_Click
End Sub


Private Sub Form_Resize()
Dim hgt As Single

    hgt = ScaleHeight - picCanvas.Top
    If hgt < 8 Then hgt = 8
    picCanvas.Move 0, picCanvas.Top, ScaleWidth, hgt

    DrawField
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


Private Sub mnuFileNewGame_Click()
Const MASS_MIN As Single = 10
Const MASS_MAX As Single = 30
Dim i As Integer
Dim black_hole As BlackHole
Dim xmin As Single
Dim xmax As Single
Dim ymin As Single
Dim ymax As Single

    xmin = 50 + MASS_MAX
    xmax = picCanvas.ScaleWidth - 50 - MASS_MAX
    ymin = MASS_MAX
    ymax = picCanvas.ScaleHeight - MASS_MAX

    Set m_BlackHoles = New Collection
    For i = 1 To 5
        Set black_hole = New BlackHole
        black_hole.Randomize xmin, xmax, ymin, ymax, MASS_MIN, MASS_MAX
        m_BlackHoles.Add black_hole
    Next i

    DrawField
End Sub

Private Sub tmrMoveShot_Timer()
Dim black_hole As BlackHole
Dim should_stop As Boolean

    ' Apply the black holes' forces.
    For Each black_hole In m_BlackHoles
        black_hole.UpdateVelocity m_BulletX, m_BulletY, m_Vx, m_Vy
    Next black_hole

    ' Move the cannon ball.
    m_BulletX = m_BulletX + m_Vx
    m_BulletY = m_BulletY + m_Vy

    ' Draw the new cannon ball.
    picCanvas.Circle (m_BulletX, m_BulletY), CANNON_HGT / 2, vbBlack

    ' See if the bullet has left the field.
    If (m_BulletY < 0) Or _
       (m_BulletY > picCanvas.ScaleHeight) Or _
       (m_BulletX < 0) Or _
       (m_BulletX > picCanvas.ScaleWidth) _
    Then
        should_stop = True
    End If

    ' See if the bullet has hit a black hole.
    If Not should_stop Then
        For Each black_hole In m_BlackHoles
            If black_hole.Hit(m_BulletX, m_BulletY, CANNON_HGT / 2) Then
                should_stop = True
                Exit For
            End If
        Next black_hole
    End If

    ' See if the bullet hit the target.
    If Not should_stop Then
        If CirclesOverlap( _
            m_BulletX, m_BulletY, CANNON_HGT / 2, _
            picCanvas.ScaleWidth, m_Cy, 15) _
        Then
            should_stop = True
            picCanvas.PaintPicture _
                picBoom.Picture, _
                picCanvas.ScaleWidth - 16, m_Cy - 16
            MsgBox "Great shot!"
        End If
    End If

    ' See if we should stop.
    If should_stop Then
        ' Stop running.
        tmrMoveShot.Enabled = False

        ' Re-enable UI elements.
        cmdFire.Enabled = True
        txtDegrees.Enabled = True
        txtSpeed.Enabled = True
        txtDegrees.SetFocus
        Screen.MousePointer = vbDefault
    End If
End Sub
Private Sub txtDegrees_Change()
    DrawField
End Sub


